variables:
  MAVEN_OPTS: "-Drepos.url=$MAVEN_REPO_URL -Drepos.login=$MAVEN_REPO_LOGIN -Drepos.password=$MAVEN_REPO_PASSWORD -Dsonar.host.url=$SONAR_URL -Dsonar.branch=$CI_BUILD_REF_NAME -Dsonar.login=$SONAR_TOKEN -Dsonar.projectName=$CI_PROJECT_PATH"

stages:
  - build
  - analize
  - prepare
  - ship

maven:
  image: $DOCKER_REGISTRY/nhs-shared/app-builder:latest
  services:
    - postgres:9.6
  variables:
    POSTGRES_DB: employer
    POSTGRES_USER: employer
    POSTGRES_PASSWORD: password
    TESTING_DATABASE_URL: postgres
    TESTING_DATABASE_PORT: "5432"
  stage: build
  artifacts:
    expire_in: 1 hour
    paths:
      - target/*
  script:
    - mvn -f liquibase/pom.xml liquibase:update@test-employer-database -Dliquibase.url="jdbc:postgresql://postgres:5432/employer"
    - mvn $MAVEN_OPTS clean install
  tags:
    - docker

sonar:
  image: $DOCKER_REGISTRY/nhs-shared/app-builder
  stage: analize
  dependencies:
    - maven
  script:
    - mvn $MAVEN_OPTS sonar:sonar
    - "echo Coverage: $(curl -u ${SONAR_TOKEN}: ${SONAR_URL}/api/measures/component?componentKey=nhs-bsa-finance:employer-details:${CI_BUILD_REF_NAME}$(echo '&')metricKeys=coverage | jq -r '.component.measures[0].value')%"
  tags:
    - docker

liquibase:
  image: $DOCKER_REGISTRY/nhs-shared/app-builder:latest
  services:
    - postgres:9.6
  variables:
    POSTGRES_DB: employer
    POSTGRES_USER: employer
    POSTGRES_PASSWORD: password
  stage: prepare
  artifacts:
    paths:
      - liquibase/target/liquibase/migrate.sql
  script:
    - mvn -f liquibase/pom.xml liquibase:updateSQL@employer-database -Dliquibase.url="jdbc:postgresql://postgres:5432/employer"
  tags:
    - docker

maven repo:
  image: $DOCKER_REGISTRY/nhs-shared/app-builder:latest
  stage: ship
  dependencies:
    - maven
  script:
    - mvn $MAVEN_OPTS -DskipTests deploy
  tags:
    - docker
  only:
    - master

dockerize:
  image: $DOCKER_REGISTRY/nhs-shared/app-builder:latest
  stage: ship
  dependencies:
    - maven
  before_script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $DOCKER_REGISTRY
  script:
    - mvn $MAVEN_OPTS docker:build
    - docker tag nhs-bsa/employer-details $DOCKER_REGISTRY/$CI_PROJECT_PATH
    - docker push $DOCKER_REGISTRY/$CI_PROJECT_PATH
  tags:
    - docker
  only:
    - master
